// -*- C++ -*-
/* 
 * File:   setFunctionPointers_template.inc
 * Author: denis
 *
 * Created on July 13, 2012, 1:50 PM
 */


#ifndef CURRENT_CLASS
#error CURRENT_CLASS definition is required!
#endif

#ifdef CURRENT_VERSION_NAMESPACE
#error CURRENT_VERSION_NAMESPACE should be undefined!
#endif

#ifdef LAST_CLASS_VERSION
#define MAXIMUM_VERSION LAST_CLASS_VERSION
#endif


#ifndef MAXIMUM_VERSION
#error MAXIMUM_VERSION definition is required!
#endif

#if MAXIMUM_VERSION == 0
    //------------------------------------------------------------------------------
    bool CURRENT_CLASS::setFunctionPointers(){

        /// Switch between versions
        switch(_version){
            case 0:
                #define CURRENT_VERSION_NAMESPACE version0
	      STANDARD_ROUTINES    BIND_STADARD_FUNCTIONS
                #undef CURRENT_VERSION_NAMESPACE
                break; ///< Version 0
            default: GENERATE_DATAFORMAT_WRONG_VERSION_EXCEPTION; break;
        }// end of switch version

        #undef CURRENT_CLASS
        #undef MAXIMUM_VERSION
        return true;
    }
#elif MAXIMUM_VERSION == 1
    //------------------------------------------------------------------------------
    bool CURRENT_CLASS::setFunctionPointers(){
        /// Switch between versions
        switch(_version){
            case 0:
                #define CURRENT_VERSION_NAMESPACE version0
                    STANDARD_ROUTINES    BIND_STADARD_FUNCTIONS
                #undef CURRENT_VERSION_NAMESPACE
                break; ///< Version 0
            case 1:
                #define CURRENT_VERSION_NAMESPACE version1
                    STANDARD_ROUTINES    BIND_STADARD_FUNCTIONS
                #undef CURRENT_VERSION_NAMESPACE
                break; ///< Version 1
            default: GENERATE_DATAFORMAT_WRONG_VERSION_EXCEPTION; break;
        }// end of switch version

        #undef CURRENT_CLASS
        #undef MAXIMUM_VERSION
        return true;
    }

#elif MAXIMUM_VERSION == 2
    //------------------------------------------------------------------------------
    bool CURRENT_CLASS::setFunctionPointers(){
        /// Switch between versions
        switch(_version){
            case 0:
                #define CURRENT_VERSION_NAMESPACE version0
                    STANDARD_ROUTINES    BIND_STADARD_FUNCTIONS
                #undef CURRENT_VERSION_NAMESPACE
                break; ///< Version 0
            case 1:
                #define CURRENT_VERSION_NAMESPACE version1
                    STANDARD_ROUTINES    BIND_STADARD_FUNCTIONS
                #undef CURRENT_VERSION_NAMESPACE
                break; ///< Version 1
            case 2:
                #define CURRENT_VERSION_NAMESPACE version2
                    STANDARD_ROUTINES    BIND_STADARD_FUNCTIONS
                #undef CURRENT_VERSION_NAMESPACE
                break; ///< Version 2
            default: GENERATE_DATAFORMAT_WRONG_VERSION_EXCEPTION; break;
        }// end of switch version

        #undef CURRENT_CLASS
        #undef MAXIMUM_VERSION
        return true;
    }
#elif MAXIMUM_VERSION == 3
    //------------------------------------------------------------------------------
    bool CURRENT_CLASS::setFunctionPointers(){
        /// Switch between versions
        switch(_version){
            case 0:
                #define CURRENT_VERSION_NAMESPACE version0
                    STANDARD_ROUTINES    BIND_STADARD_FUNCTIONS
                #undef CURRENT_VERSION_NAMESPACE
                break; ///< Version 0
            case 1:
                #define CURRENT_VERSION_NAMESPACE version1
                    STANDARD_ROUTINES    BIND_STADARD_FUNCTIONS
                #undef CURRENT_VERSION_NAMESPACE
                break; ///< Version 1
            case 2:
                #define CURRENT_VERSION_NAMESPACE version2
                    STANDARD_ROUTINES    BIND_STADARD_FUNCTIONS
                #undef CURRENT_VERSION_NAMESPACE
                break; ///< Version 2
            case 3:
                #define CURRENT_VERSION_NAMESPACE version3
                    STANDARD_ROUTINES    BIND_STADARD_FUNCTIONS
                #undef CURRENT_VERSION_NAMESPACE
                break; ///< Version 3
            default: GENERATE_DATAFORMAT_WRONG_VERSION_EXCEPTION; break;
        }// end of switch version

        #undef CURRENT_CLASS
        #undef MAXIMUM_VERSION
        return true;
    }
#elif MAXIMUM_VERSION == 4
    //------------------------------------------------------------------------------
    bool CURRENT_CLASS::setFunctionPointers(){
        /// Switch between versions
        switch(_version){
            case 0:
                #define CURRENT_VERSION_NAMESPACE version0
                    STANDARD_ROUTINES    BIND_STADARD_FUNCTIONS
                #undef CURRENT_VERSION_NAMESPACE
                break; ///< Version 0
            case 1:
                #define CURRENT_VERSION_NAMESPACE version1
                    STANDARD_ROUTINES    BIND_STADARD_FUNCTIONS
                #undef CURRENT_VERSION_NAMESPACE
                break; ///< Version 1
            case 2:
                #define CURRENT_VERSION_NAMESPACE version2
                    STANDARD_ROUTINES    BIND_STADARD_FUNCTIONS
                #undef CURRENT_VERSION_NAMESPACE
                break; ///< Version 2
            case 3:
                #define CURRENT_VERSION_NAMESPACE version3
                    STANDARD_ROUTINES    BIND_STADARD_FUNCTIONS
                #undef CURRENT_VERSION_NAMESPACE
                break; ///< Version 3
            case 4:
                #define CURRENT_VERSION_NAMESPACE version4
                    STANDARD_ROUTINES    BIND_STADARD_FUNCTIONS
                #undef CURRENT_VERSION_NAMESPACE
                break; ///< Version 4
            default: GENERATE_DATAFORMAT_WRONG_VERSION_EXCEPTION; break;
        }// end of switch version

        #undef CURRENT_CLASS
        #undef MAXIMUM_VERSION
        return true;
    }
#elif MAXIMUM_VERSION == 5
    //------------------------------------------------------------------------------
    bool CURRENT_CLASS::setFunctionPointers(){
        /// Switch between versions
        switch(_version){
            case 0:
                #define CURRENT_VERSION_NAMESPACE version0
                    STANDARD_ROUTINES    BIND_STADARD_FUNCTIONS
                #undef CURRENT_VERSION_NAMESPACE
                break; ///< Version 0
            case 1:
                #define CURRENT_VERSION_NAMESPACE version1
                    STANDARD_ROUTINES    BIND_STADARD_FUNCTIONS
                #undef CURRENT_VERSION_NAMESPACE
                break; ///< Version 1
            case 2:
                #define CURRENT_VERSION_NAMESPACE version2
                    STANDARD_ROUTINES    BIND_STADARD_FUNCTIONS
                #undef CURRENT_VERSION_NAMESPACE
                break; ///< Version 2
            case 3:
                #define CURRENT_VERSION_NAMESPACE version3
                    STANDARD_ROUTINES    BIND_STADARD_FUNCTIONS
                #undef CURRENT_VERSION_NAMESPACE
                break; ///< Version 3
            case 4:
                #define CURRENT_VERSION_NAMESPACE version4
                    STANDARD_ROUTINES    BIND_STADARD_FUNCTIONS
                #undef CURRENT_VERSION_NAMESPACE
                break; ///< Version 4
            case 5:
                #define CURRENT_VERSION_NAMESPACE version5
                    STANDARD_ROUTINES    BIND_STADARD_FUNCTIONS
                #undef CURRENT_VERSION_NAMESPACE
                break; ///< Version 5
            default: GENERATE_DATAFORMAT_WRONG_VERSION_EXCEPTION; break;
        }// end of switch version

        #undef CURRENT_CLASS
        #undef MAXIMUM_VERSION
        return true;
    }
#else
#error Need to implement more versions in setFunctionPointers.inc
#endif

